import { AuthenticatedAction } from "../classes/actions/authenticatedAction";
import { APIData } from "../modules/apiData";
import { ActionPermission } from "../models/Permission";
import { ParamsFrom } from "actionhero";
export declare class NotificationsList extends AuthenticatedAction {
    name: string;
    description: string;
    outputExample: {};
    permission: ActionPermission;
    inputs: {
        readonly limit: {
            readonly required: true;
            readonly default: 100;
            readonly formatter: typeof APIData.ensureNumber;
        };
        readonly offset: {
            readonly required: true;
            readonly default: 0;
            readonly formatter: typeof APIData.ensureNumber;
        };
        readonly order: {
            readonly required: false;
            readonly formatter: typeof APIData.ensureArray;
            readonly default: readonly [readonly ["createdAt", "desc"]];
        };
    };
    runWithinTransaction({ params, }: {
        params: ParamsFrom<NotificationsList>;
    }): Promise<{
        total: number;
        unreadCount: number;
        notifications: {
            id: string;
            from: string;
            subject: string;
            body: string;
            cta: string;
            ctaLink: string;
            createdAt: number;
            updatedAt: number;
            readAt: number;
        }[];
    }>;
}
export declare class NotificationView extends AuthenticatedAction {
    name: string;
    description: string;
    outputExample: {};
    permission: ActionPermission;
    inputs: {
        readonly id: {
            readonly required: true;
        };
    };
    runWithinTransaction({ params, }: {
        params: ParamsFrom<NotificationView>;
    }): Promise<{
        notification: {
            id: string;
            from: string;
            subject: string;
            body: string;
            cta: string;
            ctaLink: string;
            createdAt: number;
            updatedAt: number;
            readAt: number;
        };
    }>;
}
