import "isomorphic-fetch";
import { Action, ParamsFrom } from "actionhero";
import { oAuthProvider, oAuthIdentity } from "../modules/oAuth";
import { CLSAction } from "../classes/actions/clsAction";
export declare type TelemetryError = {
    message: string;
    sql: string;
};
export declare class OAuthListProviders extends Action {
    name: string;
    description: string;
    inputs: {
        readonly type: {
            readonly required: false;
        };
    };
    outputExample: {};
    run({ params }: {
        params: ParamsFrom<OAuthListProviders>;
    }): Promise<{
        error?: TelemetryError;
        providers: oAuthProvider[];
    }>;
}
export declare class OAuthClientStart extends CLSAction {
    name: string;
    description: string;
    outputExample: {};
    inputs: {
        readonly id: {
            readonly required: false;
        };
        readonly provider: {
            readonly required: true;
        };
        readonly type: {
            readonly required: true;
        };
        readonly appId: {
            readonly required: false;
        };
        readonly appOption: {
            readonly required: false;
        };
    };
    runWithinTransaction({ params, }: {
        params: ParamsFrom<OAuthClientStart>;
    }): Promise<{
        location: string;
        error: TelemetryError;
    }>;
}
export declare class OAuthClientEdit extends CLSAction {
    name: string;
    description: string;
    inputs: {
        readonly requestId: {
            readonly required: true;
        };
    };
    runWithinTransaction({ params, }: {
        params: ParamsFrom<OAuthClientEdit>;
    }): Promise<{
        oAuthRequest: {
            id: string;
            type: import("../modules/oAuth").oAuthType;
            consumed: boolean;
            provider: string;
            token: string;
            identities: oAuthIdentity[];
            appId: string;
            appOption: string;
        };
    }>;
}
export declare class OAuthClientView extends CLSAction {
    name: string;
    description: string;
    inputs: {
        readonly requestId: {
            readonly required: true;
        };
    };
    runWithinTransaction({ params, }: {
        params: ParamsFrom<OAuthClientView>;
    }): Promise<{
        oAuthRequest: {
            id: string;
            type: import("../modules/oAuth").oAuthType;
            consumed: boolean;
            provider: string;
            token: string;
            identities: oAuthIdentity[];
            appId: string;
            appOption: string;
        };
    }>;
}
