import { TeamMember } from "../models/TeamMember";
import { AuthenticatedAction } from "../classes/actions/authenticatedAction";
import { ActionPermission } from "../models/Permission";
export declare class ResetCluster extends AuthenticatedAction {
    name: string;
    description: string;
    outputExample: {};
    permission: ActionPermission;
    runWithinTransaction({ session: { teamMember }, }: {
        session: {
            teamMember: TeamMember;
        };
    }): Promise<{
        success: boolean;
        counts: {
            [model: string]: number;
        };
    }>;
}
export declare class ResetData extends AuthenticatedAction {
    name: string;
    description: string;
    outputExample: {};
    permission: ActionPermission;
    runWithinTransaction({ session: { teamMember }, }: {
        session: {
            teamMember: TeamMember;
        };
    }): Promise<{
        success: boolean;
    }>;
}
export declare class ResetCache extends AuthenticatedAction {
    name: string;
    description: string;
    outputExample: {};
    permission: ActionPermission;
    runWithinTransaction({ session: { teamMember }, }: {
        session: {
            teamMember: TeamMember;
        };
    }): Promise<{
        success: boolean;
    }>;
}
