import { ParamsFrom } from "actionhero";
import { AuthenticatedAction } from "../classes/actions/authenticatedAction";
import { APIData } from "../modules/apiData";
import { ActionPermission } from "../models/Permission";
export declare class SetupStepsList extends AuthenticatedAction {
    name: string;
    description: string;
    permission: ActionPermission;
    outputExample: {};
    isWriteTransaction(): boolean;
    runWithinTransaction(): Promise<{
        setupSteps: {
            id: string;
            position: number;
            key: string;
            title: string;
            description: string;
            href: string;
            cta: string;
            helpLink: string;
            showCtaOnCommunity: boolean;
            outcome: string;
            disabled: boolean;
            skipped: boolean;
            complete: boolean;
            createdAt: number;
            updatedAt: number;
        }[];
    }>;
}
export declare class SetupStepEdit extends AuthenticatedAction {
    name: string;
    description: string;
    permission: ActionPermission;
    outputExample: {};
    inputs: {
        readonly id: {
            readonly required: true;
        };
        readonly skipped: {
            readonly required: false;
            readonly formatter: typeof APIData.ensureBoolean;
        };
    };
    runWithinTransaction({ params, }: {
        params: ParamsFrom<SetupStepEdit>;
    }): Promise<{
        setupStep: {
            id: string;
            position: number;
            key: string;
            title: string;
            description: string;
            href: string;
            cta: string;
            helpLink: string;
            showCtaOnCommunity: boolean;
            outcome: string;
            disabled: boolean;
            skipped: boolean;
            complete: boolean;
            createdAt: number;
            updatedAt: number;
        };
    }>;
}
