import { Action } from "actionhero";
import { AuthenticatedAction } from "../classes/actions/authenticatedAction";
import { Status } from "../modules/status";
import { ActionPermission } from "../models/Permission";
export declare class PublicStatus extends Action {
    name: string;
    description: string;
    outputExample: {};
    run(): Promise<{
        status: string;
    }>;
}
export declare class PrivateStatus extends AuthenticatedAction {
    name: string;
    description: string;
    permission: ActionPermission;
    outputExample: {};
    runWithinTransaction(): Promise<{
        clusterName: string;
        id: string;
        actionheroVersion: string;
        packageName: any;
        description: any;
        version: any;
        runMode: import("../modules/runMode").GrouparooRunMode;
        uptime: number;
        metrics: Status.StatusGetResponse;
        leader: string;
    }>;
}
