import { CLI, ParamsFrom } from "actionhero";
export declare class CI extends CLI {
    name: string;
    description: string;
    inputs: {
        readonly projectId: {
            readonly required: true;
            readonly description: "Grouparoo Cloud Project ID";
            readonly letter: "p";
        };
        readonly token: {
            readonly required: false;
            readonly description: "Grouparoo Cloud Organization Token. This can also be set by using the GROUPAROO_CLOUD_API_TOKEN environment variable.";
            readonly letter: "t";
        };
        readonly message: {
            readonly required: false;
            readonly description: "Optional message to describe the Configuration.";
            readonly letter: "m";
        };
        readonly externalUrl: {
            readonly required: false;
            readonly description: "Optional external url attached to the Configuration.";
            readonly letter: "u";
        };
    };
    constructor();
    preInitialize(): void;
    run({ params }: {
        params: Partial<ParamsFrom<CI>>;
    }): Promise<boolean>;
}
