"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Console = void 0;
const cli_1 = require("../modules/cli");
const REPL = __importStar(require("repl"));
const actionhero_1 = require("actionhero");
class Console extends actionhero_1.CLI {
    constructor() {
        super();
        this.name = "console";
        this.description = "Start an interactive REPL session with the api object in-scope";
        this.preInitialize = () => {
            cli_1.GrouparooCLI.setGrouparooRunMode(this);
            cli_1.GrouparooCLI.setNextDevelopmentMode();
        };
        cli_1.GrouparooCLI.timestampOption(this);
    }
    async run() {
        cli_1.GrouparooCLI.logCLI(this.name);
        await new Promise((resolve, reject) => {
            const repl = REPL.start({
                prompt: "[🦘::" + actionhero_1.env + " ] >> ",
                input: process.stdin,
                output: process.stdout,
                useGlobal: false,
            });
            repl.context.api = actionhero_1.api;
            repl.on("exit", resolve);
            repl.on("error", reject);
        });
        return true;
    }
}
exports.Console = Console;
