"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Deploy = void 0;
const actionhero_1 = require("actionhero");
const cli_1 = require("../modules/cli");
const cloudCli_1 = require("../modules/cloudCli");
class Deploy extends actionhero_1.CLI {
    constructor() {
        super();
        this.name = "deploy";
        this.description = "Packages and applies config";
        this.inputs = {
            projectId: {
                required: true,
                description: "Grouparoo Cloud Project ID",
                letter: "p",
            },
            token: {
                required: false,
                description: "Grouparoo Cloud Organization Token. This can also be set by using the GROUPAROO_CLOUD_API_TOKEN environment variable.",
                letter: "t",
            },
            message: {
                required: false,
                description: "Optional message to describe the Configuration.",
                letter: "m",
            },
            externalUrl: {
                required: false,
                description: "Optional external url attached to the Configuration.",
                letter: "u",
            },
        };
        cli_1.GrouparooCLI.timestampOption(this);
    }
    preInitialize() {
        cli_1.GrouparooCLI.setGrouparooRunMode(this);
        cli_1.GrouparooCLI.setNextDevelopmentMode();
    }
    async run({ params }) {
        cli_1.GrouparooCLI.logCLI(this.name);
        await cloudCli_1.CloudCLI.packAndPush({ ...params, apply: true });
        return true;
    }
}
exports.Deploy = Deploy;
