"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pack = void 0;
const actionhero_1 = require("actionhero");
const cli_1 = require("../modules/cli");
const cloudCli_1 = require("../modules/cloudCli");
class Pack extends actionhero_1.CLI {
    constructor() {
        super();
        this.name = "pack";
        this.description = "Packages a grouparoo project into a .tar.gz archive";
        this.inputs = {
            output: {
                required: false,
                default: "./grouparoo.tar.gz",
                description: "Where should we generate the archive?",
                letter: "o",
            },
        };
        this.preInitialize = () => {
            cli_1.GrouparooCLI.setGrouparooRunMode(this);
            cli_1.GrouparooCLI.setNextDevelopmentMode();
        };
        cli_1.GrouparooCLI.timestampOption(this);
    }
    async run({ params }) {
        cli_1.GrouparooCLI.logCLI(this.name);
        await cloudCli_1.CloudCLI.pack(params.output);
        return true;
    }
}
exports.Pack = Pack;
