import { CLI, ParamsFrom } from "actionhero";
export declare class RunCLI extends CLI {
    name: string;
    description: string;
    inputs: {
        readonly reset: {
            readonly default: false;
            readonly description: "[DANGER] Empty the cluster of all GrouparooRecord data before starting the run? Equivalent to `grouparoo reset data`";
            readonly letter: "r";
            readonly flag: true;
        };
        readonly "reset-high-watermarks": {
            readonly default: false;
            readonly description: "Should we run all Schedules from the beginning?";
            readonly letter: "m";
            readonly flag: true;
        };
        readonly "no-export": {
            readonly description: "Skip exporting the records";
            readonly letter: "n";
            readonly flag: true;
        };
        readonly web: {
            readonly default: false;
            readonly description: "Enable the web server during this run?";
            readonly letter: "w";
            readonly flag: true;
        };
        readonly scheduleIds: {
            readonly description: "Only run specific Schedules by id";
            readonly required: false;
            readonly requiredValue: true;
            readonly variadic: true;
            readonly letter: "s";
            readonly placeholder: "schedule ids";
        };
    };
    constructor();
    preInitialize: () => void;
    run({ params, }: {
        params: Partial<ParamsFrom<RunCLI> & {
            export?: string;
            resetHighWatermarks?: string;
        }>;
    }): Promise<boolean>;
    checkWorkers(): boolean;
    checkSchedules(scheduleIds?: string[]): Promise<void>;
    stopScheduleRuns(): Promise<void>;
    runTasks(scheduleIds?: string[]): Promise<void>;
}
