import Sequelize from "sequelize";
declare const namespace = "sequelize";
declare module "actionhero" {
    interface ActionheroConfigInterface {
        [namespace]: ReturnType<typeof DEFAULT[typeof namespace]>;
    }
}
export declare const DEFAULT: {
    sequelize: (config: Record<string, any>) => {
        _toExpand: boolean;
        logging: (message: string, time: number) => void;
        benchmark: boolean;
        autoMigrate: boolean;
        dialect: string;
        port: number;
        database: string;
        host: string;
        username: string;
        password: string;
        schema: string;
        searchPath: string;
        models: string[];
        migrations: string[];
        migrationLogLevel: string;
        storage: string;
        dialectOptions: {
            ssl: boolean | {
                [key: string]: any;
            };
            prependSearchPath: boolean;
        };
        transactionType: string;
        pool: {
            max: number;
            min: number;
            acquire: number;
            idle: number;
            evict: number;
        };
        retry: {
            match: (typeof Sequelize.ConnectionError | typeof Sequelize.DatabaseError)[];
            backoffBase: number;
            backoffExponent: number;
            max: number;
            timeout: number;
        };
    };
};
export {};
