import { Initializer } from "actionhero";
import { GrouparooPlugin } from "../classes/plugin";
declare module "actionhero" {
    interface Api {
        plugins: {
            plugins: GrouparooPlugin[];
            validate: (plugin: GrouparooPlugin) => boolean;
            register: (plugin: GrouparooPlugin, validate: boolean) => void;
            announcePlugins: () => void;
            persistentConnections: {
                [id: string]: any;
            };
        };
    }
}
export declare class Plugins extends Initializer {
    constructor();
    initialize(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    validatePlugin(plugin: GrouparooPlugin): boolean;
    registerPlugin(plugin: GrouparooPlugin, validate?: boolean): void;
    announcePlugins(): void;
    checkPluginEnvironmentVariables(): void;
}
