"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelemetryInitializer = void 0;
const actionhero_1 = require("actionhero");
const clsInitializer_1 = require("../classes/initializers/clsInitializer");
const telemetry_1 = require("../modules/telemetry");
const runMode_1 = require("../modules/runMode");
const configUser_1 = require("../modules/configUser");
class TelemetryInitializer extends clsInitializer_1.CLSInitializer {
    constructor() {
        super();
        this.name = "telemetry";
        this.startPriority = 20; // start after codeConfig to include configured data
    }
    async initializeWithinTransaction() { }
    async startWithinTransaction() {
        if ((0, runMode_1.getGrouparooRunMode)() === "cli:config") {
            await configUser_1.ConfigUser.loadOrStoreCustomerId();
            await telemetry_1.Telemetry.send("cli_config");
        }
    }
    async stopWithinTransaction() {
        if ((0, runMode_1.getGrouparooRunMode)() === "cli:run")
            await telemetry_1.Telemetry.send("cli_run", actionhero_1.api.process.stopReasons);
    }
}
exports.TelemetryInitializer = TelemetryInitializer;
