"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    up: async (queryInterface, DataTypes) => {
        await queryInterface.createTable("apps", {
            guid: {
                type: DataTypes.STRING(40),
                primaryKey: true,
            },
            createdAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            updatedAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            name: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            type: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            state: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
        });
        await queryInterface.addIndex("apps", ["name"], {
            unique: true,
            fields: ["name"],
        });
        await queryInterface.addIndex("apps", ["state"], {
            fields: ["state"],
        });
    },
    down: async (queryInterface) => {
        await queryInterface.dropTable("apps");
    },
};
