"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    up: async (queryInterface, DataTypes) => {
        await queryInterface.createTable("settings", {
            guid: {
                type: DataTypes.STRING(40),
                primaryKey: true,
            },
            createdAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            updatedAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            pluginName: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            key: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            value: {
                type: DataTypes.TEXT,
                allowNull: true,
            },
            defaultValue: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            description: {
                type: DataTypes.TEXT,
                allowNull: true,
            },
        });
        await queryInterface.addIndex("settings", ["pluginName", "key"], {
            unique: true,
            fields: ["pluginName", "key"],
        });
        await queryInterface.addIndex("settings", ["pluginName"], {
            fields: ["pluginName"],
        });
    },
    down: async (queryInterface) => {
        await queryInterface.dropTable("settings");
    },
};
