"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    up: async (queryInterface, DataTypes) => {
        const TABLES = [
            "apps",
            "sources",
            "groups",
            "destinations",
            "profilePropertyRules",
            "schedules",
        ];
        for (const i in TABLES) {
            const table = TABLES[i];
            const columns = table === "profilePropertyRules" ? ["key"] : ["name"];
            await queryInterface.removeIndex(table, columns, {
                unique: true,
                fields: columns,
            });
        }
    },
    down: async (queryInterface) => {
        const TABLES = [
            "apps",
            "sources",
            "groups",
            "destinations",
            "profilePropertyRules",
            "schedules",
        ];
        for (const i in TABLES) {
            const table = TABLES[i];
            const columns = table === "profilePropertyRules" ? ["key"] : ["name"];
            await queryInterface.addIndex(table, columns, {
                unique: true,
                fields: columns,
            });
        }
    },
};
