"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    up: async (queryInterface, DataTypes) => {
        await queryInterface.createTable("destinationGroupMemberships", {
            guid: {
                type: DataTypes.STRING(40),
                primaryKey: true,
            },
            createdAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            updatedAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            destinationGuid: {
                type: DataTypes.STRING(40),
                allowNull: false,
            },
            groupGuid: {
                type: DataTypes.STRING(40),
                allowNull: false,
            },
            remoteKey: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
        });
        await queryInterface.addIndex("destinationGroupMemberships", ["destinationGuid", "groupGuid"], {
            unique: true,
            fields: ["destinationGuid", "groupGuid"],
        });
        await queryInterface.addIndex("destinationGroupMemberships", ["destinationGuid", "remoteKey"], {
            unique: true,
            fields: ["destinationGuid", "remoteKey"],
        });
    },
    down: async (queryInterface) => {
        await queryInterface.dropTable("destinationGroupMemberships");
    },
};
