"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    up: async (queryInterface, DataTypes) => {
        await queryInterface.createTable("setupSteps", {
            guid: {
                type: DataTypes.STRING(40),
                primaryKey: true,
            },
            position: {
                type: DataTypes.BIGINT,
                allowNull: false,
            },
            key: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            skipped: {
                type: DataTypes.BOOLEAN,
                allowNull: false,
            },
            complete: {
                type: DataTypes.BOOLEAN,
                allowNull: false,
            },
            createdAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            updatedAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
        });
        await queryInterface.addIndex("setupSteps", ["key"], {
            unique: true,
            fields: ["key"],
        });
    },
    down: async (queryInterface, DataTypes) => {
        await queryInterface.dropTable("setupSteps");
    },
};
