"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    up: async (queryInterface, DataTypes) => {
        await queryInterface.createTable("sessions", {
            id: {
                type: DataTypes.STRING(40),
                primaryKey: true,
            },
            createdAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            updatedAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
            teamMemberId: {
                type: DataTypes.STRING(191),
                allowNull: false,
            },
            fingerprint: {
                type: DataTypes.TEXT,
                allowNull: false,
            },
            expiresAt: {
                type: DataTypes.DATE,
                allowNull: false,
            },
        });
        await queryInterface.addIndex("sessions", ["fingerprint"], {
            unique: true,
            fields: ["fingerprint"],
        });
    },
    down: async (queryInterface) => {
        await queryInterface.dropTable("sessions");
    },
};
