"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const migration_1 = require("../utils/migration");
exports.default = {
    up: async (queryInterface) => {
        const manualGroupsCount = await migration_1.MigrationUtils.countRows(queryInterface, "groups", "type != 'calculated'");
        if (manualGroupsCount > 0) {
            throw new Error("There are manual Groups. Grouparoo v0.8 removes support for Manual Groups.  Please remove them and try again.");
        }
        await queryInterface.removeColumn("groups", "type");
    },
    down: async (queryInterface, DataTypes) => {
        await queryInterface.addColumn("groups", "type", {
            type: DataTypes.STRING(191),
            allowNull: false,
        });
    },
};
