import { ActionPermissionTopic, ActionPermissionMode, Permission } from "./Permission";
import { CommonModel } from "../classes/commonModel";
export declare class ApiKey extends CommonModel<ApiKey> {
    idPrefix(): string;
    name: string;
    apiKey: string;
    locked: string;
    permissionAllRead: boolean;
    permissionAllWrite: boolean;
    permissions: Permission[];
    static buildApiKey(instance: ApiKey): Promise<void>;
    apiData(): Promise<{
        id: string;
        name: string;
        apiKey: string;
        locked: string;
        permissionAllRead: boolean;
        permissionAllWrite: boolean;
        permissions: {
            id: string;
            topic: "file" | "record" | "source" | "group" | "import" | "system" | "run" | "resque" | "log" | "model" | "app" | "property" | "export" | "destination" | "apiKey" | "notification" | "setupStep" | "team";
            read: boolean;
            write: boolean;
            locked: string;
        }[];
        createdAt: number;
        updatedAt: number;
    }>;
    authorizeAction(topic: ActionPermissionTopic, mode: ActionPermissionMode): Promise<boolean>;
    setPermissions(userPermissions: {
        topic: string;
        read: boolean;
        write: boolean;
    }[]): Promise<void>;
    static noUpdateIfLocked(instance: ApiKey): Promise<void>;
    static buildPermissions(instance: ApiKey): Promise<void>;
    static noDestroyIfLocked(instance: ApiKey): Promise<void>;
    static deletePermissions(instance: ApiKey, {}: {}): Promise<number>;
}
