import { App } from "./App";
import { CommonModel } from "../classes/commonModel";
declare const STATES: readonly ["draft", "ready"];
export declare class AppRefreshQuery extends CommonModel<AppRefreshQuery> {
    idPrefix(): string;
    appId: string;
    refreshQuery: string;
    value: string;
    locked: string;
    state: typeof STATES[number];
    lastChangedAt: Date;
    lastConfirmedAt: Date;
    recurringFrequency: number;
    app: App;
    apiData(): Promise<{
        id: string;
        appId: string;
        refreshQuery: string;
        value: string;
        locked: string;
        state: "ready" | "draft";
        lastChangedAt: number;
        lastConfirmedAt: number;
        recurringFrequency: number;
        createdAt: number;
        updatedAt: number;
    }>;
    test(refreshQuery?: string): Promise<{
        success: boolean;
        message: string;
        error: any;
    }>;
    query(): Promise<string>;
    shouldRun(): Promise<boolean>;
    triggerSchedules(stopRuns?: Boolean): Promise<import("./Run").Run[]>;
    static ensureOnePerApp(instance: AppRefreshQuery): Promise<void>;
    static noUpdateIfLocked(instance: AppRefreshQuery): Promise<void>;
    static updateState(instance: AppRefreshQuery): Promise<void>;
    static appQuery(instance: AppRefreshQuery): Promise<void>;
    static checkRecurringFrequency(instance: AppRefreshQuery): Promise<void>;
    static noDestroyIfLocked(instance: AppRefreshQuery): Promise<void>;
}
export {};
