"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DestinationGroupMembership = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Group_1 = require("./Group");
const Destination_1 = require("./Destination");
const apiData_1 = require("../modules/apiData");
const commonModel_1 = require("../classes/commonModel");
let DestinationGroupMembership = class DestinationGroupMembership extends commonModel_1.CommonModel {
    constructor() {
        super(...arguments);
        this.uniqueIdentifier = ["groupId", "destinationId", "remoteKey"];
    }
    idPrefix() {
        return "dgm";
    }
    async apiData() {
        return {
            destinationId: this.destinationId,
            groupId: this.groupId,
            remoteKey: this.remoteKey,
            createdAt: apiData_1.APIData.formatDate(this.createdAt),
            updatedAt: apiData_1.APIData.formatDate(this.updatedAt),
        };
    }
};
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.ForeignKey)(() => Group_1.Group),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], DestinationGroupMembership.prototype, "groupId", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.ForeignKey)(() => Destination_1.Destination),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], DestinationGroupMembership.prototype, "destinationId", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.Length)({ min: 1, max: 191 }),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], DestinationGroupMembership.prototype, "remoteKey", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => Group_1.Group),
    __metadata("design:type", Group_1.Group)
], DestinationGroupMembership.prototype, "group", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => Destination_1.Destination),
    __metadata("design:type", Destination_1.Destination)
], DestinationGroupMembership.prototype, "destination", void 0);
DestinationGroupMembership = __decorate([
    (0, sequelize_typescript_1.Table)({ tableName: "destinationGroupMemberships", paranoid: false })
], DestinationGroupMembership);
exports.DestinationGroupMembership = DestinationGroupMembership;
