import { Property } from "./Property";
import { Schedule } from "./Schedule";
import { CommonModel } from "../classes/commonModel";
import { FilterOpsDescriptions } from "../modules/filterOpsDictionary";
export declare class Filter extends CommonModel<Filter> {
    idPrefix(): string;
    ownerId: string;
    ownerType: string;
    key: string;
    position: number;
    match: string;
    op: keyof typeof FilterOpsDescriptions;
    relativeMatchNumber: number;
    relativeMatchUnit: string;
    relativeMatchDirection: string;
    property: Property;
    schedule: Schedule;
    uniqueIdentifier: string[];
    apiData(): Promise<{
        id: string;
        ownerId: string;
        ownerType: string;
        key: string;
        position: number;
        match: string;
        op: "substring" | "exists" | "notExists" | "eq" | "ne" | "gt" | "lt" | "gte" | "lte" | "notSubstring";
        relativeMatchNumber: number;
        relativeMatchUnit: string;
        relativeMatchDirection: string;
        createdAt: number;
        updatedAt: number;
    }>;
}
