"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Filter = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Property_1 = require("./Property");
const Schedule_1 = require("./Schedule");
const apiData_1 = require("../modules/apiData");
const commonModel_1 = require("../classes/commonModel");
let Filter = class Filter extends commonModel_1.CommonModel {
    constructor() {
        super(...arguments);
        this.uniqueIdentifier = ["position", "ownerId"];
    }
    idPrefix() {
        return "flt";
    }
    async apiData() {
        return {
            id: this.id,
            ownerId: this.ownerId,
            ownerType: this.ownerType,
            key: this.key,
            position: this.position,
            match: this.match,
            op: this.op,
            relativeMatchNumber: this.relativeMatchNumber,
            relativeMatchUnit: this.relativeMatchUnit,
            relativeMatchDirection: this.relativeMatchDirection,
            createdAt: apiData_1.APIData.formatDate(this.createdAt),
            updatedAt: apiData_1.APIData.formatDate(this.updatedAt),
        };
    }
};
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.ForeignKey)(() => Property_1.Property),
    (0, sequelize_typescript_1.ForeignKey)(() => Schedule_1.Schedule),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Filter.prototype, "ownerId", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Filter.prototype, "ownerType", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Filter.prototype, "key", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], Filter.prototype, "position", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Filter.prototype, "match", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.Column)("string"),
    __metadata("design:type", Object)
], Filter.prototype, "op", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], Filter.prototype, "relativeMatchNumber", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Filter.prototype, "relativeMatchUnit", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Filter.prototype, "relativeMatchDirection", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => Property_1.Property),
    __metadata("design:type", Property_1.Property)
], Filter.prototype, "property", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => Schedule_1.Schedule),
    __metadata("design:type", Schedule_1.Schedule)
], Filter.prototype, "schedule", void 0);
Filter = __decorate([
    (0, sequelize_typescript_1.Table)({ tableName: "filters", paranoid: false })
], Filter);
exports.Filter = Filter;
