import { Group } from "./Group";
import { Property } from "./Property";
import { CommonModel } from "../classes/commonModel";
import { GroupRuleOpType, RelativeMatchDirectionType, RelativeMatchUnitType } from "../modules/ruleOpsDictionary";
export declare class GroupRule extends CommonModel<GroupRule> {
    idPrefix(): string;
    groupId: string;
    propertyId: string;
    recordColumn: string;
    position: number;
    match: string;
    op: GroupRuleOpType;
    relativeMatchNumber: number;
    relativeMatchUnit: RelativeMatchUnitType;
    relativeMatchDirection: RelativeMatchDirectionType;
    schedule: Group;
    property: Property;
    apiData(): Promise<{
        id: string;
        groupId: string;
        propertyId: string;
        recordColumn: string;
        position: number;
        match: string;
        op: GroupRuleOpType;
        relativeMatchNumber: number;
        relativeMatchUnit: "years" | "quarters" | "months" | "weeks" | "days";
        relativeMatchDirection: RelativeMatchDirectionType;
        createdAt: number;
        updatedAt: number;
    }>;
    static ensureEitherPropertyOrRecordColumn(instance: GroupRule): Promise<void>;
}
