"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupRule = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Group_1 = require("./Group");
const Property_1 = require("./Property");
const apiData_1 = require("../modules/apiData");
const commonModel_1 = require("../classes/commonModel");
let GroupRule = class GroupRule extends commonModel_1.CommonModel {
    idPrefix() {
        return "grr";
    }
    async apiData() {
        return {
            id: this.id,
            groupId: this.groupId,
            propertyId: this.propertyId,
            recordColumn: this.recordColumn,
            position: this.position,
            match: this.match,
            op: this.op,
            relativeMatchNumber: this.relativeMatchNumber,
            relativeMatchUnit: this.relativeMatchUnit,
            relativeMatchDirection: this.relativeMatchDirection,
            createdAt: apiData_1.APIData.formatDate(this.createdAt),
            updatedAt: apiData_1.APIData.formatDate(this.updatedAt),
        };
    }
    // --- Class Methods --- //
    static async ensureEitherPropertyOrRecordColumn(instance) {
        if ((!instance.propertyId && !instance.recordColumn) ||
            (instance.propertyId && instance.recordColumn)) {
            throw new Error("either propertyId or recordColumn is required for a GroupRule");
        }
    }
};
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.ForeignKey)(() => Group_1.Group),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GroupRule.prototype, "groupId", void 0);
__decorate([
    (0, sequelize_typescript_1.ForeignKey)(() => Property_1.Property),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GroupRule.prototype, "propertyId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GroupRule.prototype, "recordColumn", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GroupRule.prototype, "position", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GroupRule.prototype, "match", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.Column)(sequelize_typescript_1.DataType.STRING),
    __metadata("design:type", String)
], GroupRule.prototype, "op", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GroupRule.prototype, "relativeMatchNumber", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)(sequelize_typescript_1.DataType.STRING),
    __metadata("design:type", String)
], GroupRule.prototype, "relativeMatchUnit", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)(sequelize_typescript_1.DataType.STRING),
    __metadata("design:type", String)
], GroupRule.prototype, "relativeMatchDirection", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => Group_1.Group),
    __metadata("design:type", Group_1.Group)
], GroupRule.prototype, "schedule", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => Property_1.Property),
    __metadata("design:type", Property_1.Property)
], GroupRule.prototype, "property", void 0);
__decorate([
    sequelize_typescript_1.BeforeSave,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [GroupRule]),
    __metadata("design:returntype", Promise)
], GroupRule, "ensureEitherPropertyOrRecordColumn", null);
GroupRule = __decorate([
    (0, sequelize_typescript_1.Table)({ tableName: "groupRules", paranoid: false })
], GroupRule);
exports.GroupRule = GroupRule;
