import { GrouparooRecord } from "./GrouparooRecord";
import { Run } from "./Run";
import { CommonModel } from "../classes/commonModel";
export interface ImportData {
    [key: string]: any;
}
export interface ImportRecordProperties {
    [key: string]: any;
}
declare const IMPORT_CREATORS: readonly ["run", "group"];
declare const STATES: readonly ["associating", "importing", "processing", "failed", "complete"];
export declare class Import extends CommonModel<Import> {
    idPrefix(): string;
    state: typeof STATES[number];
    creatorType: typeof IMPORT_CREATORS[number];
    creatorId: string;
    get data(): ImportData;
    set data(value: ImportData);
    recordId: string;
    record: GrouparooRecord;
    createdRecord: boolean;
    startedAt: Date;
    recordAssociatedAt: Date;
    importedAt: Date;
    processedAt: Date;
    errorMessage: string;
    errorMetadata: string;
    run: Run;
    apiData(): Promise<{
        state: "failed" | "complete" | "processing" | "importing" | "associating";
        id: string;
        creatorType: "group" | "run";
        creatorId: string;
        recordId: string;
        modelId: string;
        data: ImportData;
        createdAt: number;
        startedAt: number;
        recordAssociatedAt: number;
        importedAt: number;
        processedAt: number;
        createdRecord: boolean;
        errorMessage: string;
        errorMetadata: string;
    }>;
    setError(error: Error, step: string): Promise<void>;
    static defaultState: typeof STATES[number];
    static updateState(instance: Import): Promise<void>;
    static sweep(limit: number): Promise<{
        count: number;
        days: number;
    }>;
}
export {};
