import { App } from "./App";
import { oAuthIdentity, oAuthType } from "../modules/oAuth";
import { CommonModel } from "../classes/commonModel";
export declare class OAuthRequest extends CommonModel<OAuthRequest> {
    idPrefix(): string;
    provider: string;
    type: oAuthType;
    get identities(): oAuthIdentity[];
    set identities(value: oAuthIdentity[]);
    token: string;
    consumed: boolean;
    appId: string;
    appOption: string;
    telemetryCustomer: App;
    apiData(): Promise<{
        id: string;
        type: oAuthType;
        consumed: boolean;
        provider: string;
        token: string;
        identities: oAuthIdentity[];
        appId: string;
        appOption: string;
    }>;
    static sweep(limit: number): Promise<{
        count: number;
        days: number;
    }>;
}
