"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var OAuthRequest_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.OAuthRequest = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const moment_1 = __importDefault(require("moment"));
const App_1 = require("./App");
const commonModel_1 = require("../classes/commonModel");
const sequelize_1 = require("sequelize");
let OAuthRequest = OAuthRequest_1 = class OAuthRequest extends commonModel_1.CommonModel {
    idPrefix() {
        return "req";
    }
    get identities() {
        var _a;
        return JSON.parse((_a = this.getDataValue("identities")) !== null && _a !== void 0 ? _a : "[]");
    }
    set identities(value) {
        this.setDataValue("identities", JSON.stringify(value !== null && value !== void 0 ? value : "[]"));
    }
    async apiData() {
        return {
            id: this.id,
            type: this.type,
            consumed: this.consumed,
            provider: this.provider,
            token: this.consumed ? null : this.token,
            identities: this.consumed ? [] : this.identities,
            appId: this.appId,
            appOption: this.appOption,
        };
    }
    // --- Class Methods --- //
    static async sweep(limit) {
        const days = 1;
        const count = await OAuthRequest_1.destroy({
            where: {
                createdAt: { [sequelize_1.Op.lt]: (0, moment_1.default)().subtract(days, "days").toDate() },
            },
            limit,
        });
        return { count, days };
    }
};
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OAuthRequest.prototype, "provider", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.Column)("string"),
    __metadata("design:type", String)
], OAuthRequest.prototype, "type", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)(sequelize_typescript_1.DataType.TEXT),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], OAuthRequest.prototype, "identities", null);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(true),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OAuthRequest.prototype, "token", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    (0, sequelize_typescript_1.Default)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", Boolean)
], OAuthRequest.prototype, "consumed", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(true),
    (0, sequelize_typescript_1.ForeignKey)(() => App_1.App),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OAuthRequest.prototype, "appId", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(true),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OAuthRequest.prototype, "appOption", void 0);
__decorate([
    (0, sequelize_typescript_1.BelongsTo)(() => App_1.App),
    __metadata("design:type", App_1.App)
], OAuthRequest.prototype, "telemetryCustomer", void 0);
OAuthRequest = OAuthRequest_1 = __decorate([
    (0, sequelize_typescript_1.Table)({ tableName: "oAuthRequests", paranoid: false })
], OAuthRequest);
exports.OAuthRequest = OAuthRequest;
