import { App } from "./App";
import { Source } from "./Source";
import { Destination } from "./Destination";
import { CommonModel } from "../classes/commonModel";
export declare const OptionTypes: readonly ["boolean", "string", "number"];
export declare class Option extends CommonModel<Option> {
    idPrefix(): string;
    ownerId: string;
    ownerType: string;
    key: string;
    value: string;
    type: typeof OptionTypes[number];
    app: App;
    source: Source;
    destination: Destination;
    uniqueIdentifier: string[];
    apiData(): Promise<{
        id: string;
        ownerId: string;
        ownerType: string;
        key: string;
        value: string | number | boolean;
        createdAt: number;
        updatedAt: number;
    }>;
    typedValue(): string | number | boolean;
    static validateType(instance: Option): Promise<void>;
}
