"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Session_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Session = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const TeamMember_1 = require("./TeamMember");
const apiData_1 = require("../modules/apiData");
const sequelize_1 = require("sequelize");
const actionhero_1 = require("actionhero");
const commonModel_1 = require("../classes/commonModel");
let Session = Session_1 = class Session extends commonModel_1.CommonModel {
    idPrefix() {
        return "ses";
    }
    async apiData() {
        return {
            id: this.id,
            teamMemberId: this.teamMemberId,
            fingerprint: this.fingerprint,
            createdAt: apiData_1.APIData.formatDate(this.createdAt),
            updatedAt: apiData_1.APIData.formatDate(this.updatedAt),
            expiresAt: apiData_1.APIData.formatDate(this.expiresAt),
        };
    }
    // --- Class Methods --- //
    static async sweep() {
        const now = new Date();
        const count = await Session_1.destroy({
            where: { expiresAt: { [sequelize_1.Op.lt]: now } },
            force: true,
        });
        const days = actionhero_1.api.session.ttl / 1000 / 60 / 60 / 24;
        return { count, days };
    }
};
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    (0, sequelize_typescript_1.ForeignKey)(() => TeamMember_1.TeamMember),
    __metadata("design:type", String)
], Session.prototype, "teamMemberId", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Session.prototype, "fingerprint", void 0);
__decorate([
    (0, sequelize_typescript_1.AllowNull)(false),
    sequelize_typescript_1.Column,
    __metadata("design:type", Date)
], Session.prototype, "expiresAt", void 0);
Session = Session_1 = __decorate([
    (0, sequelize_typescript_1.Table)({ tableName: "sessions", paranoid: false })
], Session);
exports.Session = Session;
