import { SettingConfigurationObject } from "../classes/codeConfig";
import { CommonModel } from "../classes/commonModel";
export declare const settingTypes: readonly ["string", "number", "boolean"];
export declare class Setting extends CommonModel<Setting> {
    idPrefix(): string;
    pluginName: string;
    key: string;
    get value(): string;
    set value(data: string);
    defaultValue: string;
    type: typeof settingTypes[number];
    locked: string;
    title: string;
    description: string;
    variant: string;
    uniqueIdentifier: string[];
    apiData(): Promise<{
        id: string;
        pluginName: string;
        key: string;
        title: string;
        value: string;
        type: "string" | "number" | "boolean";
        variant: string;
        defaultValue: string;
        description: string;
        locked: string;
        createdAt: number;
        updatedAt: number;
    }>;
    getConfigId(): string;
    getConfigObject(): Promise<SettingConfigurationObject>;
    static validateType(instance: Setting): Promise<void>;
    static validateValue(instance: Setting): void;
    static noUpdateIfLocked(instance: Setting): Promise<void>;
    static noDestroyIfLocked(instance: Setting): Promise<void>;
}
