import { SetupStepDescription } from "../modules/ops/setupSteps";
import { CommonModel } from "../classes/commonModel";
export declare class SetupStep extends CommonModel<SetupStep> {
    idPrefix(): string;
    position: number;
    key: string;
    skipped: boolean;
    complete: boolean;
    apiData(modelId?: string): Promise<{
        id: string;
        position: number;
        key: string;
        title: string;
        description: string;
        href: string;
        cta: string;
        helpLink: string;
        showCtaOnCommunity: boolean;
        outcome: string;
        disabled: boolean;
        skipped: boolean;
        complete: boolean;
        createdAt: number;
        updatedAt: number;
    }>;
    getTitle(ssd?: SetupStepDescription, modelId?: string): string;
    getDescription(ssd?: SetupStepDescription, modelId?: string): string;
    getHref(ssd?: SetupStepDescription, modelId?: string): string;
    getCta(ssd?: SetupStepDescription, modelId?: string): string;
    getHelpLink(ssd?: SetupStepDescription, modelId?: string): string;
    getShowCtaOnCommunity(ssd?: SetupStepDescription, modelId?: string): boolean;
    performCheck(ssd?: SetupStepDescription, modelId?: string): Promise<boolean>;
    getOutcome(ssd?: SetupStepDescription, modelId?: string): Promise<string>;
    getDisabled(ssd?: SetupStepDescription, modelId?: string): Promise<boolean>;
    getSetupStepDescription(modelId: string): {
        position: number;
        key: string;
        title: string;
        description: string;
        href: string;
        cta: string;
        helpLink: string;
        showCtaOnCommunity?: boolean;
        check?: () => Promise<boolean>;
        outcome?: () => Promise<string>;
        disabled: () => Promise<boolean>;
        runModes: string[];
    };
}
