import { Team } from "./Team";
import { CommonModel } from "../classes/commonModel";
export declare class TeamMember extends CommonModel<TeamMember> {
    idPrefix(): string;
    teamId: string;
    locked: string;
    firstName: string;
    lastName: string;
    email: string;
    passwordHash: string;
    lastLoginAt: Date;
    team: Team;
    apiData(): Promise<{
        id: string;
        teamId: string;
        firstName: string;
        lastName: string;
        email: string;
        locked: string;
        lastLoginAt: Date;
        createdAt: number;
        updatedAt: number;
    }>;
    updatePassword(password: string): Promise<boolean>;
    checkPassword(password: string): Promise<boolean>;
    static lowercaseEmail(instance: TeamMember): void;
    static ensureTeamExists(instance: TeamMember): Promise<void>;
    static noUpdateIfLocked(instance: TeamMember): Promise<void>;
    static sendTelemetry(): Promise<void>;
    static noDestroyIfLocked(instance: TeamMember): Promise<void>;
}
