"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModelsCache = void 0;
const modelCache_1 = require("../modelCache");
const GrouparooModel_1 = require("../../models/GrouparooModel");
async function findAllWithCache(modelId, state) {
    const now = Date.now();
    if (this.expires > now && this.instances.length > 0) {
        return this.instances.filter((a) => !state || a.state === state);
    }
    else {
        this.instances = await GrouparooModel_1.GrouparooModel.unscoped().findAll({
            include: this.include(),
        });
        this.expires = now + this.TTL;
        return this.instances.filter((a) => !state || a.state === state);
    }
}
async function findOneWithCache(value, modelId, state, lookupKey = "id") {
    const instances = await this.findAllWithCache();
    let instance = instances.find((i) => i[lookupKey] === value);
    if (!instance) {
        const where = { [lookupKey]: value };
        if (state)
            where.state = state;
        instance = await GrouparooModel_1.GrouparooModel.unscoped().findOne({
            where,
            include: this.include(),
        });
        if (instance)
            this.invalidate();
    }
    return instance;
}
exports.ModelsCache = new modelCache_1.ModelCache(findAllWithCache, findOneWithCache, () => []);
