import { CLI } from "actionhero";
import { FinalSummary } from "./status";
import { FinalSummaryReporters } from "../../../core/src/modules/statusReporters";
export declare namespace GrouparooCLI {
    /** Types */
    interface LogStatus {
        [key: string]: number[] | string[];
    }
    type LogStatusArray = {
        header: string;
        status: LogStatus;
    }[];
    /** Settings and Boot Options */
    function timestampOption(cli: CLI): void;
    function jsonOption(cli: CLI): void;
    function setGrouparooRunMode(cli: CLI): string;
    function setNextDevelopmentMode(nextDevelopmentMode?: boolean): void;
    function logCLI(name: string, announcePlugins?: boolean): void;
    function disableWebServer(): void;
    /** Logging */
    /**
     * We do not want to use the actionhero logger for CLI commands, as we do not want this info in the log files.
     * We also want more fine-grained control of log display for the terminal.
     */
    namespace logger {
        function log(message: string): void;
        function error(message: string): void;
        function blueBold(s: string): string;
        function cyanBold(s: string): string;
        function blue(s: string): string;
        function underlineBold(s: string): string;
        function deCamel(s: string): string;
        function deCamelAndCapitalize(s: string): string;
        function fatal(message: string): boolean;
        function status(title: string, statusArray: LogStatusArray, secondaryTitle?: string): void;
        function generateSummaryItems(categorySummary: FinalSummaryReporters.GrouparooRecords.RecordData[] | FinalSummaryReporters.Sources.SourceData[] | FinalSummaryReporters.Destinations.DestinationData[] | FinalSummaryReporters.Warnings.WarningData[], logBlock: string): boolean;
        function finalSummary(finalSummaryLogs: FinalSummary.FinalSummaryLogArray, secondaryTitle?: string): void;
    }
}
