import { AnyConfigurationObject, IdsByClass } from "../../classes/codeConfig";
export declare function getSeenIds(configObjects: AnyConfigurationObject[]): IdsByClass;
export declare function loadConfigDirectory(configDir: string | false, externallyValidate?: boolean): Promise<{
    seenIds: IdsByClass;
    errors: string[];
    deletedIds: IdsByClass;
}>;
export declare function loadConfigObjects(configDir: string | false): Promise<{
    configObjects: AnyConfigurationObject[];
    errors: string[];
}>;
export declare function shouldExternallyValidate(canExternallyValidate: boolean, configObject: AnyConfigurationObject, locallyValidateIds: Set<string>): Promise<boolean>;
export declare function processConfigObjects(configObjects: AnyConfigurationObject[], canExternallyValidate: boolean, locallyValidateIds?: Set<string>, validate?: boolean): Promise<{
    seenIds: IdsByClass;
    errors: string[];
    deletedIds: IdsByClass;
}>;
export declare function deleteLockedObjects(seenIds: IdsByClass): Promise<IdsByClass>;
