import { AnyConfigurationObject } from "../classes/codeConfig";
declare type WritableConfigObject = {
    filePath: string;
    object: AnyConfigurationObject;
};
declare type CachedConfigFile = {
    absFilePath: string;
    objects: AnyConfigurationObject[];
};
export declare namespace ConfigWriter {
    function generateId(name: string, separator?: string): string;
    function generateFilePath(object: AnyConfigurationObject | [AnyConfigurationObject], prefix?: string): string;
    function run(): Promise<WritableConfigObject[]>;
    function getConfigObjects(): Promise<WritableConfigObject[]>;
    function getConfigFileCache(): CachedConfigFile[];
    function resetConfigFileCache(): void;
    function getLockKey(configObject: AnyConfigurationObject): string | null;
    function cacheConfigFile(cacheObj: CachedConfigFile): Promise<null>;
}
export {};
