"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Deprecation = void 0;
const actionhero_1 = require("actionhero");
var Deprecation;
(function (Deprecation) {
    function warnChanged(topic, oldName, newName) {
        (0, actionhero_1.log)(`[${topic}] - deprecation warning: \`${oldName}\` has been changed to \`${newName}\` and will be removed in a future release`, "warning");
    }
    Deprecation.warnChanged = warnChanged;
    function warnReplaced(topic, oldName, newName) {
        (0, actionhero_1.log)(`[${topic}] - deprecation warning: \`${oldName}\` command has been replaced by ${newName} and will be removed in a future release.  `, "warning");
    }
    Deprecation.warnReplaced = warnReplaced;
    function warnRemoved(topic, container, property) {
        (0, actionhero_1.log)(`[${topic}] - deprecation warning: \`${container}\`.\`${property}\` has been removed and will throw an error in a future release`, "warning");
    }
    Deprecation.warnRemoved = warnRemoved;
})(Deprecation = exports.Deprecation || (exports.Deprecation = {}));
