"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildPropertyFilterDictionary = exports.FilterOpsDescriptions = void 0;
exports.FilterOpsDescriptions = {
    eq: "equals",
    ne: "does not equal",
    exists: "exists with any value",
    notExists: "does not exist",
    gt: "greater than",
    gte: "greater than or equal to",
    lt: "less than",
    lte: "less than or equal to",
    substring: "contains",
    notSubstring: "does not contain",
};
function buildPropertyFilterDictionary(options) {
    const propertyFilterDictionary = {};
    for (const option of options) {
        for (const op of option.ops) {
            if (!propertyFilterDictionary[op])
                propertyFilterDictionary[op] = exports.FilterOpsDescriptions[op];
        }
    }
    return propertyFilterDictionary;
}
exports.buildPropertyFilterDictionary = buildPropertyFilterDictionary;
