import { App, SimpleAppOptions } from "../../models/App";
export declare namespace AppOps {
    /**
     * Connect to an App
     */
    function connect(app: App, options?: SimpleAppOptions, forceReconnect?: boolean): Promise<any>;
    /**
     * Disconnect from an App
     */
    function disconnect(app: App, alreadyLocked?: boolean): Promise<void>;
    /**
     * Test an App's Connection
     */
    function test(app: App, options?: SimpleAppOptions): Promise<{
        success: boolean;
        message: string;
        error: any;
    }>;
}
