import { AppRefreshQuery } from "../../models/AppRefreshQuery";
import { Run } from "../../models/Run";
export declare namespace AppRefreshQueryOps {
    /**
     * Query the app
     */
    function runAppQuery(appRefreshQuery: AppRefreshQuery, testQuery?: string): Promise<string>;
    /**
     * Trigger all schedules for all sources associated with this app.
     * Optionally, cancel existing runs on those schedules (used by actions)
     */
    function triggerSchedules(appRefreshQuery: AppRefreshQuery, stopRuns: Boolean): Promise<Run[]>;
    /**
     * Determine if it is time to run
     */
    function shouldRun(appRefreshQuery: AppRefreshQuery): Promise<boolean>;
    /**
     * Test the appRefreshQuery and return the sample value
     */
    function test(appRefreshQuery: AppRefreshQuery, testQuery?: string): Promise<{
        success: boolean;
        message: string;
        error: any;
    }>;
}
