import { Property, SimplePropertyOptions } from "../../models/Property";
import { PluginOptionType } from "../../classes/plugin";
export declare namespace PropertyOps {
    /**
     * Enqueue Runs to update all Groups that rely on this Property
     */
    function enqueueRuns(property: Property): Promise<void>;
    /**
     * Get the options for a Property from its plugin
     */
    function pluginOptions(property: Property, propertyOptions?: SimplePropertyOptions): Promise<{
        key: string;
        displayName?: string;
        description: string;
        required: boolean;
        type: PluginOptionType;
        options: {
            key: string;
            description?: string;
            default?: boolean;
            examples?: any[];
        }[];
    }[]>;
    /**
     * Returns any GrouparooRecord Properties that this Rule depends on.
     * For example, if email depends on userId, this method would return [userIdRule]
     */
    function dependencies(property: Property): Promise<Property[]>;
}
