import { Schedule } from "../../models/Schedule";
import { Run, HighWaterMark } from "../../models/Run";
export declare namespace ScheduleOps {
    function run(schedule: Schedule, run: Run): Promise<{
        importsCount: number;
        highWaterMark: HighWaterMark;
        sourceOffset: string | number;
    }>;
    /**
     * Load the options for this schedule from the plugin
     */
    function pluginOptions(schedule: Schedule): Promise<{
        key: string;
        description: string;
        required: boolean;
        type: string;
        options: {
            key: string;
            description?: string;
            examples?: any[];
        }[];
    }[]>;
    /**
     * Determine the percentage complete for this run
     */
    function runPercentComplete(schedule: Schedule, run: Run): Promise<number>;
    /**
     * Determine if it is time to run
     */
    function shouldRun(schedule: Schedule, options?: {
        ignoreDeltas?: boolean;
        runIfNotRecurring?: boolean;
    }): Promise<boolean>;
}
