import { settingTypes } from "../../models/Setting";
export declare namespace SettingOps {
    interface SettingsListItem {
        key: string;
        title: string;
        defaultValue: string | number;
        description: string;
        type: typeof settingTypes[number];
        variant?: string;
    }
    function prepare(): Promise<void>;
    function cleanSettings(inUseKeys: string[]): Promise<number>;
    function registerSettingsArray(settingsList: SettingsListItem[], pluginName: string): Promise<void>;
    const coreSettings: SettingsListItem[];
    const interfaceSettings: SettingsListItem[];
    const telemetrySettings: SettingsListItem[];
}
