"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamMemberOps = void 0;
const bcryptjs_1 = __importDefault(require("bcryptjs"));
const SALT_ROUNDS = 10;
var TeamMemberOps;
(function (TeamMemberOps) {
    /**
     * Set a Team Member's Password
     */
    async function updatePassword(teamMember, password) {
        teamMember.passwordHash = bcryptjs_1.default.hashSync(password, bcryptjs_1.default.genSaltSync(SALT_ROUNDS));
        await teamMember.save();
        return true;
    }
    TeamMemberOps.updatePassword = updatePassword;
    /**
     * Check a Team Member's Password
     */
    async function checkPassword(teamMember, password) {
        if (!teamMember.passwordHash) {
            throw new Error("password not set for this team member");
        }
        const match = await bcryptjs_1.default.compareSync(password, teamMember.passwordHash);
        return match;
    }
    TeamMemberOps.checkPassword = checkPassword;
})(TeamMemberOps = exports.TeamMemberOps || (exports.TeamMemberOps = {}));
