import { PackageJson } from "type-fest";
declare type GrouparooPackageJson = PackageJson & {
    grouparoo?: {
        grouparoo_monorepo_app?: string;
        plugins?: string[];
        env?: {
            api?: string[];
            web?: string[];
        };
        serverInjection?: string[];
    };
};
export declare const grouparooMonorepoApp: string;
export declare function readPackageJson(path: string): GrouparooPackageJson;
export declare function getParentPath(): string;
export declare function getConfigDir(throwIfDisabled: true): Promise<string>;
export declare function getConfigDir(throwIfDisabled: false): Promise<string | false>;
export declare function getConfigDir(throwIfDisabled: boolean): Promise<string | false>;
export declare function getConfigDir(): Promise<string | false>;
export declare function getCoreRootPath(): string;
export declare type PluginManifest = {
    parent: {
        path?: string;
        grouparoo: GrouparooPackageJson["grouparoo"];
    };
    plugins: {
        name: string;
        path: string;
        version: string;
        license: string;
        url: string;
        grouparoo?: GrouparooPackageJson["grouparoo"];
    }[];
    missingPlugins: string[];
};
export declare function getPluginManifest(): PluginManifest;
export declare function runningCoreDirectly(): boolean;
export declare function getCoreVersion(): string;
export declare function getNodeVersion(): string;
export {};
