import "isomorphic-fetch";
import { PluginApp } from "../classes/plugin";
export interface PluginWithVersion {
    name: string;
    description: string;
    icon: string;
    currentVersion: string;
    latestVersion: string;
    upToDate: boolean;
    license: string;
    url: string;
    installed: boolean;
    source: boolean;
    destination: boolean;
    apps: PluginApp[];
}
export declare type GrouparooManifestPackage = {
    name: string;
    description: string;
    imageUrl: string;
    packageName: string;
    source: boolean;
    destination: boolean;
    npmUrl?: string;
    docsUrl?: string;
};
export declare function listPlugins(includeInstalled?: boolean, includeAvailable?: boolean, includeVersions?: boolean): Promise<PluginWithVersion[]>;
export declare function getAvailableGrouparooPlugins(): Promise<GrouparooManifestPackage[]>;
export declare function install(pluginName: string): Promise<{
    exitCode: number;
    stdout: string;
    stderr: string;
    success: boolean;
}>;
export declare function uninstall(pluginName: string): Promise<{
    exitCode: number;
    stdout: string;
    stderr: string;
    success: boolean;
}>;
