/**
 * Utilities for deleting and resetting things
 */
export declare namespace Reset {
    /**
     * reset:cluster (most dangerous)
     * * truncates all tables except those regarding teams/members
     * * clears the redis cache
     * * clears resque
     */
    function cluster(callerId: string): Promise<{
        [model: string]: number;
    }>;
    /**
     * reset:data
     * * truncates "data" tables (records, groups, etc) but leaves apps, sources, properties
     * * clears the redis cache
     * * clears resque
     */
    function data(callerId: string): Promise<void>;
    /**
     * reset:cache (least dangerous)
     * * clears the redis cache
     * * clears resque
     */
    function cache(callerId: string): Promise<void>;
    function resetHighWatermarks(): Promise<void>;
    function clearLocalCaches(): Promise<void>;
    function clearRedis(): Promise<void>;
}
