declare const _boolean_ops: readonly [{
    readonly op: "exists";
    readonly description: "exists with any value";
}, {
    readonly op: "notExists";
    readonly description: "does not exist";
}, {
    readonly op: "eq";
    readonly description: "is equal to";
}, {
    readonly op: "ne";
    readonly description: "is not equal to";
}];
declare const _number_ops: readonly [{
    readonly op: "exists";
    readonly description: "exists with any value";
}, {
    readonly op: "notExists";
    readonly description: "does not exist";
}, {
    readonly op: "eq";
    readonly description: "is equal to";
}, {
    readonly op: "ne";
    readonly description: "is not equal to";
}, {
    readonly op: "gt";
    readonly description: "is greater than";
}, {
    readonly op: "lt";
    readonly description: "is less than";
}, {
    readonly op: "gte";
    readonly description: "is greater than or equal to";
}, {
    readonly op: "lte";
    readonly description: "is less than or equal to";
}];
declare const _string_ops_sqlite: readonly [{
    readonly op: "exists";
    readonly description: "exists with any value";
}, {
    readonly op: "notExists";
    readonly description: "does not exist";
}, {
    readonly op: "eq";
    readonly description: "is equal to";
}, {
    readonly op: "ne";
    readonly description: "is not equal to";
}, {
    readonly op: "like";
    readonly description: "is like (case sensitive)";
}, {
    readonly op: "notLike";
    readonly description: "is not like (case sensitive)";
}, {
    readonly op: "startsWith";
    readonly description: "starts with";
}, {
    readonly op: "endsWith";
    readonly description: "ends with";
}, {
    readonly op: "substring";
    readonly description: "includes the string";
}];
declare const _string_ops_postgres: readonly [{
    readonly op: "exists";
    readonly description: "exists with any value";
}, {
    readonly op: "notExists";
    readonly description: "does not exist";
}, {
    readonly op: "eq";
    readonly description: "is equal to";
}, {
    readonly op: "ne";
    readonly description: "is not equal to";
}, {
    readonly op: "like";
    readonly description: "is like (case sensitive)";
}, {
    readonly op: "notLike";
    readonly description: "is not like (case sensitive)";
}, {
    readonly op: "startsWith";
    readonly description: "starts with";
}, {
    readonly op: "endsWith";
    readonly description: "ends with";
}, {
    readonly op: "substring";
    readonly description: "includes the string";
}, {
    readonly op: "iLike";
    readonly description: "is like (case insensitive)";
}, {
    readonly op: "notILike";
    readonly description: "is not like (case insensitive)";
}];
declare const _date_ops: readonly [{
    readonly op: "exists";
    readonly description: "exists with any value";
}, {
    readonly op: "notExists";
    readonly description: "does not exist";
}, {
    readonly op: "eq";
    readonly description: "is equal to";
}, {
    readonly op: "ne";
    readonly description: "is not equal to";
}, {
    readonly op: "gt";
    readonly description: "is after";
}, {
    readonly op: "lt";
    readonly description: "is before";
}, {
    readonly op: "gte";
    readonly description: "is on or after";
}, {
    readonly op: "lte";
    readonly description: "is on or before";
}, {
    readonly op: "relative_gt";
    readonly description: "is in the past";
}, {
    readonly op: "relative_lt";
    readonly description: "is in the future";
}];
declare const _relativeMatchUnits: readonly ["days", "weeks", "months", "quarters", "years"];
export declare function buildPropertyOpsDictionary(cfg?: any): {
    boolean: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }];
    date: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "gt";
        readonly description: "is after";
    }, {
        readonly op: "lt";
        readonly description: "is before";
    }, {
        readonly op: "gte";
        readonly description: "is on or after";
    }, {
        readonly op: "lte";
        readonly description: "is on or before";
    }, {
        readonly op: "relative_gt";
        readonly description: "is in the past";
    }, {
        readonly op: "relative_lt";
        readonly description: "is in the future";
    }];
    email: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    float: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "gt";
        readonly description: "is greater than";
    }, {
        readonly op: "lt";
        readonly description: "is less than";
    }, {
        readonly op: "gte";
        readonly description: "is greater than or equal to";
    }, {
        readonly op: "lte";
        readonly description: "is less than or equal to";
    }];
    integer: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "gt";
        readonly description: "is greater than";
    }, {
        readonly op: "lt";
        readonly description: "is less than";
    }, {
        readonly op: "gte";
        readonly description: "is greater than or equal to";
    }, {
        readonly op: "lte";
        readonly description: "is less than or equal to";
    }];
    phoneNumber: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    string: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    url: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    _relativeMatchUnits: readonly ["days", "weeks", "months", "quarters", "years"];
    _convenientRules: {
        exists: {
            operation: {
                op: string;
            };
            match: string;
        };
        notExists: {
            operation: {
                op: string;
            };
            match: string;
        };
        relative_gt: {
            operation: {
                op: string;
            };
            relativeMatchDirection: string;
        };
        relative_lt: {
            operation: {
                op: string;
            };
            relativeMatchDirection: string;
        };
    };
};
export declare const PropertyOpsDictionary: {
    boolean: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }];
    date: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "gt";
        readonly description: "is after";
    }, {
        readonly op: "lt";
        readonly description: "is before";
    }, {
        readonly op: "gte";
        readonly description: "is on or after";
    }, {
        readonly op: "lte";
        readonly description: "is on or before";
    }, {
        readonly op: "relative_gt";
        readonly description: "is in the past";
    }, {
        readonly op: "relative_lt";
        readonly description: "is in the future";
    }];
    email: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    float: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "gt";
        readonly description: "is greater than";
    }, {
        readonly op: "lt";
        readonly description: "is less than";
    }, {
        readonly op: "gte";
        readonly description: "is greater than or equal to";
    }, {
        readonly op: "lte";
        readonly description: "is less than or equal to";
    }];
    integer: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "gt";
        readonly description: "is greater than";
    }, {
        readonly op: "lt";
        readonly description: "is less than";
    }, {
        readonly op: "gte";
        readonly description: "is greater than or equal to";
    }, {
        readonly op: "lte";
        readonly description: "is less than or equal to";
    }];
    phoneNumber: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    string: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    url: readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }] | readonly [{
        readonly op: "exists";
        readonly description: "exists with any value";
    }, {
        readonly op: "notExists";
        readonly description: "does not exist";
    }, {
        readonly op: "eq";
        readonly description: "is equal to";
    }, {
        readonly op: "ne";
        readonly description: "is not equal to";
    }, {
        readonly op: "like";
        readonly description: "is like (case sensitive)";
    }, {
        readonly op: "notLike";
        readonly description: "is not like (case sensitive)";
    }, {
        readonly op: "startsWith";
        readonly description: "starts with";
    }, {
        readonly op: "endsWith";
        readonly description: "ends with";
    }, {
        readonly op: "substring";
        readonly description: "includes the string";
    }, {
        readonly op: "iLike";
        readonly description: "is like (case insensitive)";
    }, {
        readonly op: "notILike";
        readonly description: "is not like (case insensitive)";
    }];
    _relativeMatchUnits: readonly ["days", "weeks", "months", "quarters", "years"];
    _convenientRules: {
        exists: {
            operation: {
                op: string;
            };
            match: string;
        };
        notExists: {
            operation: {
                op: string;
            };
            match: string;
        };
        relative_gt: {
            operation: {
                op: string;
            };
            relativeMatchDirection: string;
        };
        relative_lt: {
            operation: {
                op: string;
            };
            relativeMatchDirection: string;
        };
    };
};
export declare type GroupRuleOpType = typeof _boolean_ops[number]["op"] | typeof _number_ops[number]["op"] | typeof _string_ops_sqlite[number]["op"] | typeof _string_ops_postgres[number]["op"] | typeof _date_ops[number]["op"];
export declare type RelativeMatchUnitType = typeof _relativeMatchUnits[number];
export declare type RelativeMatchDirectionType = "add" | "subtract";
export {};
