"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spawnPromise = void 0;
const child_process_1 = require("child_process");
const actionhero_1 = require("actionhero");
const os_1 = __importDefault(require("os"));
async function spawnPromise(command, args = [], cwd = process.cwd(), extraEnv = {}) {
    const { exitCode, stdout, stderr, } = await new Promise((resolve) => {
        let stdout = "";
        let stderr = "";
        actionhero_1.chatRoom.broadcast({}, "system:cli", {
            type: "stdout",
            message: "$ " +
                command.replace("./node_modules/.bin/", "") +
                " " +
                args.join(" "),
            timestamp: new Date().getTime(),
        });
        actionhero_1.chatRoom.broadcast({}, "system:cli", {
            type: "stdout",
            message: "",
        });
        const spawnProcess = (0, child_process_1.spawn)(command, args, {
            cwd,
            env: Object.assign(extraEnv, process.env),
        });
        spawnProcess.stdout.on("data", async (data) => {
            stdout += String(data);
            const lines = String(data).split(os_1.default.EOL);
            for (const line of lines) {
                await actionhero_1.chatRoom.broadcast({}, "system:cli", {
                    type: "stdout",
                    message: line,
                    timestamp: new Date().getTime(),
                });
            }
        });
        spawnProcess.stderr.on("data", async (data) => {
            stdout += String(data);
            const lines = String(data).split(os_1.default.EOL);
            for (const line of lines) {
                await actionhero_1.chatRoom.broadcast({}, "system:cli", {
                    type: "stderr",
                    message: line,
                    timestamp: new Date().getTime(),
                });
            }
        });
        spawnProcess.on("close", (exitCode) => {
            resolve({ exitCode, stdout, stderr });
        });
    });
    return { exitCode, stdout, stderr, success: exitCode === 0 };
}
exports.spawnPromise = spawnPromise;
