import { StatusMetric, FinalSummaryReporters } from "./statusReporters";
export declare namespace Status {
    const maxSamples = 50;
    const sampleFrequencyMS: number;
    const cachePrefix: string;
    interface StatusObject {
        timestamp: number;
        metric: StatusMetric;
    }
    type StatusGetResponse = {
        [topic: string]: {
            [collection: string]: StatusObject[];
        };
    };
    const statusSampleReporters: ((() => Promise<StatusMetric>) | (() => Promise<StatusMetric[]>))[];
    function get(limit?: number): Promise<StatusGetResponse>;
    function set(metrics: StatusMetric | StatusMetric[], ttl?: number): Promise<StatusObject[]>;
    function setAll(): Promise<void>;
    function getCurrent(): Promise<StatusGetResponse>;
}
export declare namespace FinalSummary {
    type FinalSummaryLogArray = (FinalSummaryReporters.Sources.SourceData[] | FinalSummaryReporters.GrouparooRecords.RecordData[] | FinalSummaryReporters.Destinations.DestinationData[] | FinalSummaryReporters.Warnings.WarningData[])[];
    function getFinalSummary(): Promise<FinalSummaryLogArray>;
}
