import "isomorphic-fetch";
import { StatusMetric } from "./../modules/statusReporters";
export declare namespace Telemetry {
    const TELEMETRY_CALL_TRIGGERS: readonly ["timer", "team", "cli_run", "cli_config"];
    export type TelemetryCallTrigger = typeof TELEMETRY_CALL_TRIGGERS[number];
    export function send(trigger: TelemetryCallTrigger, errors?: string[], toThrowOnError?: boolean): Promise<boolean>;
    export function build(trigger: TelemetryCallTrigger, errors?: string[]): Promise<{
        name: string;
        id: string;
        trigger: "team" | "timer" | "cli_run" | "cli_config";
        metrics: StatusMetric[];
    }>;
    export {};
}
