"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrouparooRecordsReEnqueueStuckExportingRecords = void 0;
const actionhero_1 = require("actionhero");
const sequelize_1 = __importStar(require("sequelize"));
const Import_1 = require("../../models/Import");
const clsTask_1 = require("../../classes/tasks/clsTask");
const GrouparooRecord_1 = require("../../models/GrouparooRecord");
const delay = 60 * 60 * 1000; // 1 hour
class GrouparooRecordsReEnqueueStuckExportingRecords extends clsTask_1.CLSTask {
    constructor() {
        super(...arguments);
        this.name = "records:reEnqueueStuckExportingRecords";
        this.description = "If a record has been stuck in the exporting state for a long time, try again";
        this.frequency = 1000 * 60;
        this.queue = "records";
    }
    async runWithinTransaction() {
        const limit = actionhero_1.config.batchSize.exports;
        let offset = 0;
        let imports = await getStuckImports(limit, offset);
        while (imports.length > 0) {
            await GrouparooRecord_1.GrouparooRecord.update({ state: "pending" }, { where: { id: imports.map((i) => i.recordId) } });
            offset = offset + limit;
            imports = await getStuckImports(limit, offset);
        }
    }
}
exports.GrouparooRecordsReEnqueueStuckExportingRecords = GrouparooRecordsReEnqueueStuckExportingRecords;
async function getStuckImports(limit, offset) {
    return Import_1.Import.findAll({
        attributes: [
            [sequelize_1.default.fn("DISTINCT", sequelize_1.default.col("recordId")), "recordId"],
        ],
        where: {
            state: "processing",
            importedAt: { [sequelize_1.Op.lt]: new Date(new Date().getTime() - delay) },
        },
        limit,
        offset,
    });
}
