import { RetryableTask } from "../../classes/tasks/retryableTask";
import { ParamsFrom } from "actionhero";
import { APIData } from "../../modules/apiData";
export declare class ImportRecordProperties extends RetryableTask {
    name: string;
    description: string;
    frequency: number;
    queue: string;
    inputs: {
        readonly recordIds: {
            readonly required: true;
            readonly formatter: typeof APIData.ensureArray;
        };
        readonly propertyIds: {
            readonly required: true;
            readonly formatter: typeof APIData.ensureArray;
        };
    };
    runWithinTransaction({ recordIds, propertyIds, }: ParamsFrom<ImportRecordProperties>): Promise<void>;
}
