import { ParamsFrom } from "actionhero";
import { Status } from "../../../modules/status";
import { CLSTask } from "../../../classes/tasks/clsTask";
import { Worker } from "node-resque";
import { APIData } from "../../../modules/apiData";
export declare class StatusTask extends CLSTask {
    name: string;
    description: string;
    frequency: number;
    queue: string;
    inputs: {
        readonly toStop: {
            readonly required: false;
            readonly formatter: typeof APIData.ensureBoolean;
        };
    };
    runWithinTransaction({ toStop }: ParamsFrom<StatusTask>, worker: Worker): Promise<any>;
    logFinalSummary(): Promise<void>;
    checkForComplete(samples: Status.StatusGetResponse): Promise<boolean>;
    stopServer(toStop?: boolean): Promise<boolean>;
    getSamples(): Promise<Status.StatusGetResponse>;
    logSamples(samples: Status.StatusGetResponse): void;
    updateTaskFrequency(): Promise<void>;
}
