"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelemetryAdHocTask = void 0;
const retryableTask_1 = require("../../../classes/tasks/retryableTask");
const apiData_1 = require("../../../modules/apiData");
const telemetry_1 = require("../../../modules/telemetry");
class TelemetryAdHocTask extends retryableTask_1.RetryableTask {
    constructor() {
        super(...arguments);
        this.name = "telemetry:adHoc";
        this.description = "send telemetry information about this cluster (ad hoc)";
        this.frequency = 0;
        this.queue = "system";
        this.inputs = {
            trigger: {
                required: true,
                formatter: (p) => apiData_1.APIData.ensureString(p),
            },
        };
    }
    async runWithinTransaction({ trigger }) {
        return telemetry_1.Telemetry.send(trigger, [], true);
    }
}
exports.TelemetryAdHocTask = TelemetryAdHocTask;
