"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelemetryTask = void 0;
const retryableTask_1 = require("../../../classes/tasks/retryableTask");
const apiData_1 = require("../../../modules/apiData");
const runMode_1 = require("../../../modules/runMode");
const telemetry_1 = require("../../../modules/telemetry");
class TelemetryTask extends retryableTask_1.RetryableTask {
    constructor() {
        super(...arguments);
        this.name = "telemetry";
        this.description = "send telemetry information about this cluster (recurring)";
        this.frequency = (0, runMode_1.getGrouparooRunMode)() === "cli:run" ? 0 : 1000 * 60 * 60 * 24; // every 24 hours
        this.queue = "system";
        this.inputs = {
            trigger: {
                required: true,
                default: "timer",
                formatter: (p) => apiData_1.APIData.ensureString(p),
            },
        };
    }
    async runWithinTransaction({ trigger }) {
        return telemetry_1.Telemetry.send(trigger, [], true);
    }
}
exports.TelemetryTask = TelemetryTask;
